-- Credits: Driizt, Phanx, Keju

local addonName, addonTable = ...
local L = addonTable.L
local LRI = LibStub:GetLibrary("LibRealmInfo");

local supportedRegion = {
    ["us"] = true,
    ["eu"] = true,
    ["tw"] = true,
    ["cn"] = true,
    ["kr"] = true,
}

UnitPopupButtons["WPQL"]={text = L.WPQUICKLINK, dist = 0};
UnitPopupButtons["BNWPQL"]={text = L.WPQUICKLINK, dist = 0};

UnitPopupButtons["RIOQL"]={text = L.RIOQUICKLINK, dist = 0};
UnitPopupButtons["BNRIOQL"]={text = L.RIOQUICKLINK, dist = 0};

UnitPopupButtons["WLQL"]={text = L.WLQUICKLINK, dist = 0};
UnitPopupButtons["BNWLQL"]={text = L.WLQUICKLINK, dist = 0};

-- FIXME 2017-10-13 "PLAYER" taints the menu and needs fixed
-- FIXME 2017-10-13 "PLAYER" taints the menu and needs fixed
-- FIXME 2017-10-13 "PLAYER" taints the menu and needs fixed
-- FIXME 2017-10-13 "PLAYER" taints the menu and needs fixed
-- FIXME 2017-10-13 "PLAYER" taints the menu and needs fixed

--table.insert(UnitPopupMenus["PARTY"], #(UnitPopupMenus["PARTY"])-1, "WPQL");
--table.insert(UnitPopupMenus["PLAYER"], #(UnitPopupMenus["PLAYER"])-1, "WPQL");
--table.insert(UnitPopupMenus["RAID_PLAYER"], #(UnitPopupMenus["RAID_PLAYER"])-1, "WPQL");
table.insert(UnitPopupMenus["GUILD"], #(UnitPopupMenus["GUILD"])-1, "WPQL");
table.insert(UnitPopupMenus["GUILD_OFFLINE"], #(UnitPopupMenus["GUILD_OFFLINE"])-1, "WPQL");
table.insert(UnitPopupMenus["FRIEND"], #(UnitPopupMenus["FRIEND"])-1, "WPQL");

-- keju added: [Additional links]

--table.insert(UnitPopupMenus["PARTY"], #(UnitPopupMenus["PARTY"])-1, "RIOQL");
--table.insert(UnitPopupMenus["PLAYER"], #(UnitPopupMenus["PLAYER"])-1, "RIOQL");
--table.insert(UnitPopupMenus["RAID_PLAYER"], #(UnitPopupMenus["RAID_PLAYER"])-1, "RIOQL");
table.insert(UnitPopupMenus["GUILD"], #(UnitPopupMenus["GUILD"])-1, "RIOQL");
table.insert(UnitPopupMenus["GUILD_OFFLINE"], #(UnitPopupMenus["GUILD_OFFLINE"])-1, "RIOQL");
table.insert(UnitPopupMenus["FRIEND"], #(UnitPopupMenus["FRIEND"])-1, "RIOQL");

--table.insert(UnitPopupMenus["PARTY"], #(UnitPopupMenus["PARTY"])-1, "WLQL");
--table.insert(UnitPopupMenus["PLAYER"], #(UnitPopupMenus["PLAYER"])-1, "WLQL");
--table.insert(UnitPopupMenus["RAID_PLAYER"], #(UnitPopupMenus["RAID_PLAYER"])-1, "WLQL");
table.insert(UnitPopupMenus["GUILD"], #(UnitPopupMenus["GUILD"])-1, "WLQL");
table.insert(UnitPopupMenus["GUILD_OFFLINE"], #(UnitPopupMenus["GUILD_OFFLINE"])-1, "WLQL");
table.insert(UnitPopupMenus["FRIEND"], #(UnitPopupMenus["FRIEND"])-1, "WLQL");


table.insert(UnitPopupMenus["BN_FRIEND"], #(UnitPopupMenus["BN_FRIEND"])-1, "BNWPQL");
table.insert(UnitPopupMenus["BN_FRIEND"], #(UnitPopupMenus["BN_FRIEND"])-1, "BNRIOQL");
table.insert(UnitPopupMenus["BN_FRIEND"], #(UnitPopupMenus["BN_FRIEND"])-1, "BNWLQL");

table.insert(UnitPopupMenus["FRIEND_OFFLINE"], #(UnitPopupMenus["FRIEND_OFFLINE"])-1, "WPQL");
table.insert(UnitPopupMenus["FRIEND_OFFLINE"], #(UnitPopupMenus["FRIEND_OFFLINE"])-1, "RIOQL");
table.insert(UnitPopupMenus["FRIEND_OFFLINE"], #(UnitPopupMenus["FRIEND_OFFLINE"])-1, "WLQL");

table.insert(UnitPopupMenus["CHAT_ROSTER"], #(UnitPopupMenus["CHAT_ROSTER"])-1, "WPQL");
table.insert(UnitPopupMenus["CHAT_ROSTER"], #(UnitPopupMenus["CHAT_ROSTER"])-1, "RIOQL");
table.insert(UnitPopupMenus["CHAT_ROSTER"], #(UnitPopupMenus["CHAT_ROSTER"])-1, "WLQL");

-- keju added: [BNet support]
-- https://searchcode.com/codesearch/view/116164892/1
hooksecurefunc("LFGListApplicationViewer_UpdateAvailability", function(self)
--[[
	if ( UnitIsGroupLeader("player", LE_PARTY_CATEGORY_HOME) ) then
		self.RemoveEntryButton:Show();
		self.EditButton:Show();
	else
		self.RemoveEntryButton:Hide();
		self.EditButton:Hide();
	end

	if ( IsRestrictedAccount() ) then
		self.EditButton:Disable();
		self.EditButton.tooltip = ERR_RESTRICTED_ACCOUNT_LFG_LIST_TRIAL;
	else
		self.EditButton:Enable();
		self.EditButton.tooltip = nil;
	end

	local empowered = LFGListUtil_IsEntryEmpowered();
	self.UnempoweredCover:SetShown(not empowered);
	self.ScrollFrame.NoApplicants:SetShown(empowered and (not self.applicants or #self.applicants == 0));
--]]

    if (not empowered) then
-- Hide the overlaying frame so the non-group-leader players can still right-click and copy profile links
--        self.UnempoweredCover:SetShown(false);
-- Instead of hiding the info frame, make it ignore the mouse so users can just click-through it:
        self.UnempoweredCover:EnableMouse(false);
    end

end)

local function urlEscape(url)
	return string.gsub(url, "([^A-Za-z0-9_:/?&=.-])",
		function(ch)
			return string.format("%%%02x", string.byte(ch))
		end)
end

local function GetCQLRealm(pRealm)
    local _,realm,_,_,_,_,region = LRI:GetRealmInfo(pRealm)
    return realm, region
end

local function constructUrl(name, server, linkType)
	if not name or name == "" then return end
	if not server or server == "" then server = GetRealmName() end
	local region, url;

    local msgLbl = ""

    if linkType == "WPQL" or linkType == "BNWPQL" then
        msgLbl = L.WPQLCOLORLABEL
    elseif linkType == "RIOQL" or linkType == "BNRIOQL" then
        msgLbl = L.RIOQLCOLORLABEL
    elseif linkType == "WLQL" or linkType == "BNWLQL" then
        msgLbl = L.QLQLCOLORLABEL
    end
	
    realm, region = GetCQLRealm(server)

--[[
-- Debug:
    if name ~= nil and server ~= nil then
        DEFAULT_CHAT_FRAME:AddMessage("keju wowprogressquicklink | " .. name .. " | " .. server)

        if realm then
            DEFAULT_CHAT_FRAME:AddMessage("keju wowprogressquicklink | " .. realm)
        end
    end
--]]
	
	if not realm and not region then
		if LRI:GetCurrentRegion() == "KR" then
			realm  = server
			region = "kr"
		end
	end

	if region then
		region = string.lower(region)
		if not region or region == "" then
			DEFAULT_CHAT_FRAME:AddMessage(msgLbl..L.REALMERROR);
			return;
		end
	end

	if not realm or realm == "" then
		DEFAULT_CHAT_FRAME:AddMessage(msgLbl..L.SERVERERROR);
		return;
	end

	if not supportedRegion[region] then
		DEFAULT_CHAT_FRAME:AddMessage(msgLbl.."["..string.upper(region).."]"..L.NOTSUPPORTEDLIST);
		region = nil;
		return;
	end

-- keju added: [fixed realm naming]
---	realm = realm:gsub("'","");
--	realm = realm:gsub("'","-");
--	realm = realm:gsub(" ","-");
-- keju removed: [old armory link]
--	url = "http://"..region..".battle.net/wow/"..L.LANGUAGE.."/character/"..realm.."/"..name.."/advanced";

    if linkType == "WPQL" or linkType == "BNWPQL" then
	    realm = realm:gsub("'","-");
    	realm = realm:gsub(" ","-");

        url = "https://www.wowprogress.com/character/"..region.."/"..realm.."/"..name;
    elseif linkType == "RIOQL" or linkType == "BNRIOQL" then
	    realm = realm:gsub("'","-");
    	realm = realm:gsub(" ","-");

        url = "https://www.raider.io/characters/"..region.."/"..realm.."/"..name;
    elseif linkType == "WLQL" or linkType == "BNWLQL" then
	    realm = realm:gsub("'","");
    	realm = realm:gsub(" ","-");

        url = "https://www.warcraftlogs.com/character/"..region.."/"..realm.."/"..name;
    end
	
	if url then
		url = urlEscape(url);
	end

	return url;
end

------------------------------------------------------------------------
-- keju added: [popup to copy URL instead of chat input box]
-- http://wowwiki.wikia.com/wiki/Creating_simple_pop-up_dialog_boxes
-- http://wowprogramming.com/docs/widgets/EditBox
local function ShowUrlPopup(url)

    StaticPopupDialogs["WowProgressQuickLink_URL"] = {
        text = L.WPQUICKLINK,
        button1 = "Close",
--        button2 = "Ok",
        OnShow = function (self, data)
            self.editBox:SetScript("OnEscapePressed", function(self)
                self:GetParent():Hide()
            end)

            self.editBox:SetMaxLetters(0)
            self.editBox:SetText(url)
            self.editBox:HighlightText(0, self.editBox:GetNumLetters())
        end,
        OnAccept = function()
--            local text = self.editBox:GetText()
        end,
        hasEditBox = true,
        editBoxWidth = 400,
        timeout = 0,
        whileDead = true,
        hideOnEscape = true,
        preferredIndex = 3,  -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
    }

    StaticPopup_Show("WowProgressQuickLink_URL")

end

------------------------------------------------------------------------

local function ShowUrl(name, server, linkType)
	if not name then return end
	local url = constructUrl(name, server, linkType);
	if url then
--		local edit_box = ChatEdit_ChooseBoxForSend()
--		ChatEdit_ActivateChat(edit_box)
		if url then
--			edit_box:Insert(url);
--			edit_box:HighlightText();
            ShowUrlPopup(url)
		end
	end
end

------------------------------------------------------------------------

local function LFGShowUrl(name, linkType)
	if not name then return end
	pName = gsub(name, "%-[^|]+", "")
	pServer = gsub(name, "[^|]+%-", "")
	if pName == pServer then 
		pServer = GetRealmName() 
	end
	local url = constructUrl(pName, pServer, linkType);
	if url then
--		local edit_box = ChatEdit_ChooseBoxForSend()
--		ChatEdit_ActivateChat(edit_box)
		if url then
--			edit_box:Insert(url);
--			edit_box:HighlightText();
            ShowUrlPopup(url)
		end
	end
end

------------------------------------------------------------------------

local CURRENT_NAME, CURRENT_SERVER

local BN_CURRENT_NAME = ""
local BN_CURRENT_SERVER = ""

-- FIXME : keju 2017-08-14 probably add code here to support bnet friend wowprogress link request
-- https://github.com/tomrus88/BlizzardInterfaceCode/blob/master/Interface/FrameXML/FriendsFrame.lua

-- function UnitPopup_ShowMenu (dropdownMenu, which, unit, name, userData)

hooksecurefunc("UnitPopup_ShowMenu", function(self, which, unit, name, userData)
    BN_CURRENT_NAME = ""
    BN_CURRENT_SERVER = ""

    if which == "FRIEND" and UIDROPDOWNMENU_MENU_LEVEL == 1 then
        CURRENT_NAME, CURRENT_SERVER = self.name, self.server
    elseif which == "BN_FRIEND" and UIDROPDOWNMENU_MENU_LEVEL == 1 then

        local dropdownMenu = UIDROPDOWNMENU_INIT_MENU

        local bnetIDAccount, accountName, battleTag, isBattleTagPresence,
            characterName, bnetIDGameAccount, client, isOnline, lastOnline,
            isAFK, isDND, messageText, noteText, isRIDFriend, messageTime,
            canSoR, isReferAFriend,
            canSummonFriend = BNGetFriendInfoByID(dropdownMenu.bnetIDAccount)

        local hasFocus, characterName, client, realmName, realmID, faction, race,
            class, guild, zoneName, level, gameText, broadcastText, broadcastTime,
            canSoR, toonID, bnetIDAccount, isGameAFK,
            isGameBusy  = BNGetGameAccountInfo(bnetIDGameAccount)

        if CanCooperateWithGameAccount(bnetIDGameAccount) and characterName ~= nil and characterName ~= "" then

            --DEFAULT_CHAT_FRAME:AddMessage("keju | " .. characterName)

--            local guid = "Player-" .. realmID .. "--" .. toonID
--            local className, classId, raceName, raceId, gender, name, realm = GetPlayerInfoByGUID("guid")

            CURRENT_NAME = characterName
            CURRENT_SERVER = realmName

            BN_CURRENT_NAME = CURRENT_NAME
            BN_CURRENT_SERVER = CURRENT_SERVER

-- if then realmID = GetRealmName()

            --DEFAULT_CHAT_FRAME:AddMessage("keju | " .. CURRENT_NAME .. " | " .. CURRENT_SERVER)

-- the following 2 lines didn't work. Left here as a reminder.
--            UIDROPDOWNMENU_INIT_MENU.name = CURRENT_NAME
--            UIDROPDOWNMENU_INIT_MENU.server = CURRENT_SERVER

        end
    end
end)

hooksecurefunc("UnitPopup_OnClick", function(self)
--    local name, server = UIDROPDOWNMENU_INIT_MENU.name, UIDROPDOWNMENU_INIT_MENU.server

    local name, server

-- Crude, but this works for BNET until I clean it up...
	if self.value == "WPQL" or self.value == "RIOQL" or self.value == "WLQL" then
        name = UIDROPDOWNMENU_INIT_MENU.name
        server = UIDROPDOWNMENU_INIT_MENU.server
    elseif ( self.value == "BNWPQL" or self.value == "BNRIOQL" or self.value == "BNWLQL") and BN_CURRENT_NAME and BN_CURRENT_NAME ~= "" then
        name = BN_CURRENT_NAME
        server = BN_CURRENT_SERVER
    end

    if name == CURRENT_NAME and not server then server = CURRENT_SERVER end
            
	if self.value == "WPQL" or self.value == "RIOQL" or self.value == "WLQL" then
		ShowUrl(name, server, self.value);
--	elseif self.value == "RIOQL" then
--		ShowUrl(name, server, self.value);
--	elseif self.value == "WLQL" then
--		ShowUrl(name, server, self.value);
    elseif self.value == "BNWPQL" or self.value == "BNRIOQL" or self.value == "BNWLQL" then

-- This might be sloppy, but using the global BN_CURRENT* variables which are
-- set in UnitPopup_ShowMenu were failing until the same code was moved into
-- this function...

        local dropdownMenu = UIDROPDOWNMENU_INIT_MENU

        local bnetIDAccount, accountName, battleTag, isBattleTagPresence,
            characterName, bnetIDGameAccount, client, isOnline, lastOnline,
            isAFK, isDND, messageText, noteText, isRIDFriend, messageTime,
            canSoR, isReferAFriend,
            canSummonFriend = BNGetFriendInfoByID(dropdownMenu.bnetIDAccount)

        local hasFocus, characterName, client, realmName, realmID, faction, race,
            class, guild, zoneName, level, gameText, broadcastText, broadcastTime,
            canSoR, toonID, bnetIDAccount, isGameAFK,
            isGameBusy  = BNGetGameAccountInfo(bnetIDGameAccount)

        if CanCooperateWithGameAccount(bnetIDGameAccount) and characterName ~= nil and characterName ~= "" then
            CURRENT_NAME = characterName
            CURRENT_SERVER = realmName

            BN_CURRENT_NAME = CURRENT_NAME
            BN_CURRENT_SERVER = CURRENT_SERVER
        end


        name = BN_CURRENT_NAME
        server = BN_CURRENT_SERVER

        if name == CURRENT_NAME and not server then server = CURRENT_SERVER end

--[[
        if name then
            DEFAULT_CHAT_FRAME:AddMessage("wowprogressquicklink : name = " .. name)
        else
            DEFAULT_CHAT_FRAME:AddMessage("wowprogressquicklink : name is missing")
        end
        if server then
            DEFAULT_CHAT_FRAME:AddMessage("wowprogressquicklink : server = " .. server)
        else
            DEFAULT_CHAT_FRAME:AddMessage("wowprogressquicklink : server is missing")
        end
--]]

		ShowUrl(name, server, self.value);
	end
end)

------------------------------------------------------------------------
--- PremadeGroup Finder 7.2.0
------------------------------------------------------------------------

local LFG_LIST_SEARCH_ENTRY_MENU = {
    { -- [1]
        text = nil, --Group name goes here
        isTitle = true,
        notCheckable = true,
    },
    { -- [2]
        text = WHISPER_LEADER,
        func = function(_, name) ChatFrame_SendTell(name); end,
        notCheckable = true,
        arg1 = nil, --Leader name goes here
        disabled = nil, --Disabled if we don't have a leader name yet or you haven't applied
        tooltipWhileDisabled = 1,
        tooltipOnButton = 1,
        tooltipTitle = nil, --The title to display on mouseover
        tooltipText = nil, --The text to display on mouseover
    },
	{ -- [3]
        text = L.WPQUICKLINK,
		func = function(_, name) LFGShowUrl(name, "WPQL"); end,
		notCheckable = true,
		arg1 = nil, --Player name goes here
		disabled = nil, --Disabled if we don't have a name yet
    },
	{ -- [4]
        text = L.RIOQUICKLINK,
		func = function(_, name) LFGShowUrl(name, "RIOQL"); end,
		notCheckable = true,
		arg1 = nil, --Player name goes here
		disabled = nil, --Disabled if we don't have a name yet
    },
	{ -- [5]
        text = L.WLQUICKLINK,
		func = function(_, name) LFGShowUrl(name, "WLQL"); end,
		notCheckable = true,
		arg1 = nil, --Player name goes here
		disabled = nil, --Disabled if we don't have a name yet
    },
    { -- [6]
        text = LFG_LIST_REPORT_GROUP_FOR,
        hasArrow = true,
        notCheckable = true,
        menuList = {
            {
                text = LFG_LIST_BAD_NAME,
                func = function(_, id) C_LFGList.ReportSearchResult(id, "lfglistname"); end,
                arg1 = nil, --Search result ID goes here
                notCheckable = true,
            },
            {
                text = LFG_LIST_BAD_DESCRIPTION,
                func = function(_, id) C_LFGList.ReportSearchResult(id, "lfglistcomment"); end,
                arg1 = nil, --Search reuslt ID goes here
                notCheckable = true,
                disabled = nil, --Disabled if the description is just an empty string
            },
            {
                text = LFG_LIST_BAD_VOICE_CHAT_COMMENT,
                func = function(_, id) C_LFGList.ReportSearchResult(id, "lfglistvoicechat"); end,
                arg1 = nil, --Search reuslt ID goes here
                notCheckable = true,
                disabled = nil, --Disabled if the description is just an empty string
            },
            {
                text = LFG_LIST_BAD_LEADER_NAME,
                func = function(_, id) C_LFGList.ReportSearchResult(id, "badplayername"); end,
                arg1 = nil, --Search reuslt ID goes here
                notCheckable = true,
                disabled = nil, --Disabled if we don't have a name for the leader
            },
        },
    },
    { -- [7]
        text = CANCEL,
        notCheckable = true,
    },
};

-- keju added: /slash command options

local function ChatCommands(msg)
    local cmd, cmdArgs = msg:match("^(%S*)%s*(.-)$");
--    cmd = string.upper(cmd)
    if not cmdArgs then cmdArgs = "" end

    if not cmd or cmd == "" then
        cmd = "wowprogress"
    end

    local attemptedUrl = false
    local url

    if cmd == "wowprogress" or cmd == "wp"
        or cmd == "raider.io" or cmd == "rio" or cmd == "raiderio"
        or cmd == "warcraftlogs" or cmd == "wl"
    then

        local linkType

        attemptedUrl = true

        if cmd == "wowprogress" or cmd == "wp" then
            linkType = "WPQL"
        elseif cmd == "raider.io" or cmd == "rio" or cmd == "raiderio" then
            linkType = "RIOQL"
        elseif cmd == "warcraftlogs" or cmd == "wql" then
            linkType = "WLQL"
        end

        local name = GetUnitName("target", true);

        if name and UnitIsPlayer("target") then
        	local pName = gsub(name, "%-[^|]+", "")
        	local pServer = gsub(name, "[^|]+%-", "")
        	if pName == pServer then 
        		pServer = GetRealmName() 
        	end

            -- DEFAULT_CHAT_FRAME:AddMessage(L.ADDONNAMECOLORLABEL.." :: "..pName.." :: "..pServer.." :: "..linkType);

        	url = constructUrl(pName, pServer, linkType);
        	if url then
        		if url then
                    ShowUrlPopup(url)
        		end
        	end
        end
    end

    if attemptedUrl then
        if not url then
            -- FIXME : add localization:
            DEFAULT_CHAT_FRAME:AddMessage(L.ADDONNAMECOLORLABEL.." Please have a player targetted in order to generate a character link.");
            DEFAULT_CHAT_FRAME:AddMessage(L.ADDONNAMECOLORLABEL.." With a player targetted, you may also specify:");
            DEFAULT_CHAT_FRAME:AddMessage(L.ADDONNAMECOLORLABEL.."    /cql wowprogress");
            DEFAULT_CHAT_FRAME:AddMessage(L.ADDONNAMECOLORLABEL.."    /cql raider.io");
            DEFAULT_CHAT_FRAME:AddMessage(L.ADDONNAMECOLORLABEL.."    /cql warcraftlogs");
        end
    end

--    DEFAULT_CHAT_FRAME:AddMessage(L.ADDONNAMECOLORLABEL.." Additional options coming soon...");

--    DEFAULT_CHAT_FRAME:AddMessage(L.ADDONNAMECOLORLABEL.." "..cmd.." : "..cmdArgs.." (COMING SOON)");

end

--SLASH_CQL1, SLASH_CQL2, SLASH_CQL3, SLASH_CQL4, SLASH_CQL5 = "/cql", "/Cql", "/CQl", "/CQL", "/characterquicklinks";
SLASH_CQL1, SLASH_CQL2 = "/cql", "/characterquicklinks";

SlashCmdList["CQL"] = ChatCommands;

-- keju added: end
 
function LFGListUtil_GetSearchEntryMenu(resultID)
    local id, activityID, name, comment, voiceChat, iLvl, honorLevel, age, numBNetFriends, numCharFriends, numGuildMates, isDelisted, leaderName, numMembers = C_LFGList.GetSearchResultInfo(resultID);
    local _, appStatus, pendingStatus, appDuration = C_LFGList.GetApplicationInfo(resultID);
    LFG_LIST_SEARCH_ENTRY_MENU[1].text = name;
    LFG_LIST_SEARCH_ENTRY_MENU[2].arg1 = leaderName;
    LFG_LIST_SEARCH_ENTRY_MENU[2].disabled = not leaderName;
-- keju added: [additional link options]
-- WP
    LFG_LIST_SEARCH_ENTRY_MENU[3].arg1 = leaderName;
    LFG_LIST_SEARCH_ENTRY_MENU[3].disabled = not leaderName;
-- RIO
    LFG_LIST_SEARCH_ENTRY_MENU[4].arg1 = leaderName;
    LFG_LIST_SEARCH_ENTRY_MENU[4].disabled = not leaderName;
-- WL
    LFG_LIST_SEARCH_ENTRY_MENU[5].arg1 = leaderName;
    LFG_LIST_SEARCH_ENTRY_MENU[5].disabled = not leaderName;

    LFG_LIST_SEARCH_ENTRY_MENU[6].menuList[1].arg1 = resultID;
    LFG_LIST_SEARCH_ENTRY_MENU[6].menuList[2].arg1 = resultID;
    LFG_LIST_SEARCH_ENTRY_MENU[6].menuList[2].disabled = (comment == "");
    LFG_LIST_SEARCH_ENTRY_MENU[6].menuList[3].arg1 = resultID;
    LFG_LIST_SEARCH_ENTRY_MENU[6].menuList[3].disabled = (voiceChat == "");
    LFG_LIST_SEARCH_ENTRY_MENU[6].menuList[4].arg1 = resultID;
    LFG_LIST_SEARCH_ENTRY_MENU[6].menuList[4].disabled = not leaderName;
    return LFG_LIST_SEARCH_ENTRY_MENU;
end

local LFG_LIST_APPLICANT_MEMBER_MENU = {
    { -- [1]
        text = nil, --Player name goes here
        isTitle = true,
        notCheckable = true,
    },
    { -- [2]
        text = WHISPER,
        func = function(_, name) ChatFrame_SendTell(name); end,
        notCheckable = true,
        arg1 = nil, --Player name goes here
        disabled = nil, --Disabled if we don't have a name yet
    },
    { -- [3]
        text = L.WPQUICKLINK,
		func = function(_, name) LFGShowUrl(name, "WPQL"); end,
		notCheckable = true,
		arg1 = nil, --Player name goes here
		disabled = nil, --Disabled if we don't have a name yet
    },
    { -- [4]
        text = L.RIOQUICKLINK,
		func = function(_, name) LFGShowUrl(name, "RIOQL"); end,
		notCheckable = true,
		arg1 = nil, --Player name goes here
		disabled = nil, --Disabled if we don't have a name yet
    },
    { -- [5]
        text = L.WLQUICKLINK,
		func = function(_, name) LFGShowUrl(name, "WLQL"); end,
		notCheckable = true,
		arg1 = nil, --Player name goes here
		disabled = nil, --Disabled if we don't have a name yet
    },
    { -- [6]
        text = LFG_LIST_REPORT_FOR,
        hasArrow = true,
        notCheckable = true,
        menuList = {
            {
                text = LFG_LIST_BAD_PLAYER_NAME,
                notCheckable = true,
                func = function(_, id, memberIdx) C_LFGList.ReportApplicant(id, "badplayername", memberIdx); end,
                arg1 = nil, --Applicant ID goes here
                arg2 = nil, --Applicant Member index goes here
            },
            {
                text = LFG_LIST_BAD_DESCRIPTION,
                notCheckable = true,
                func = function(_, id) C_LFGList.ReportApplicant(id, "lfglistappcomment"); end,
                arg1 = nil, --Applicant ID goes here
            },
        },
    },
    { -- [7]
        text = IGNORE_PLAYER,
        notCheckable = true,
        func = function(_, name, applicantID) AddIgnore(name); C_LFGList.DeclineApplicant(applicantID); end,
        arg1 = nil, --Player name goes here
        arg2 = nil, --Applicant ID goes here
        disabled = nil, --Disabled if we don't have a name yet
    },
    { -- [8]
        text = CANCEL,
        notCheckable = true,
    },
};
 
function LFGListUtil_GetApplicantMemberMenu(applicantID, memberIdx)
    local name, class, localizedClass, level, itemLevel, tank, healer, damage, assignedRole = C_LFGList.GetApplicantMemberInfo(applicantID, memberIdx);
    local id, status, pendingStatus, numMembers, isNew, comment = C_LFGList.GetApplicantInfo(applicantID);
    LFG_LIST_APPLICANT_MEMBER_MENU[1].text = name or " ";
    LFG_LIST_APPLICANT_MEMBER_MENU[2].arg1 = name;
    LFG_LIST_APPLICANT_MEMBER_MENU[2].disabled = not name or (status ~= "applied" and status ~= "invited");
-- keju added: [additional link options]
-- WP
    LFG_LIST_APPLICANT_MEMBER_MENU[3].arg1 = name;
    LFG_LIST_APPLICANT_MEMBER_MENU[3].disabled = not name or (status ~= "applied" and status ~= "invited");
-- RIO
    LFG_LIST_APPLICANT_MEMBER_MENU[4].arg1 = name;
    LFG_LIST_APPLICANT_MEMBER_MENU[4].disabled = not name or (status ~= "applied" and status ~= "invited");
-- WL
    LFG_LIST_APPLICANT_MEMBER_MENU[5].arg1 = name;
    LFG_LIST_APPLICANT_MEMBER_MENU[5].disabled = not name or (status ~= "applied" and status ~= "invited");

    LFG_LIST_APPLICANT_MEMBER_MENU[6].menuList[1].arg1 = applicantID;
    LFG_LIST_APPLICANT_MEMBER_MENU[6].menuList[1].arg2 = memberIdx;
    LFG_LIST_APPLICANT_MEMBER_MENU[6].menuList[2].arg1 = applicantID;
    LFG_LIST_APPLICANT_MEMBER_MENU[6].menuList[2].disabled = (comment == "");
    LFG_LIST_APPLICANT_MEMBER_MENU[7].arg1 = name;
    LFG_LIST_APPLICANT_MEMBER_MENU[7].arg2 = applicantID;
    LFG_LIST_APPLICANT_MEMBER_MENU[7].disabled = not name;
    return LFG_LIST_APPLICANT_MEMBER_MENU;
end



local frame, events = CreateFrame("Frame"), {};
function events:PLAYER_LOGIN(...)
 -- handle PLAYER_ENTERING_WORLD here
    -- FIXME : add localization:
    DEFAULT_CHAT_FRAME:AddMessage(L.ADDONNAMECOLORLABEL.." With a player targetted, you may specify:");
    DEFAULT_CHAT_FRAME:AddMessage(L.ADDONNAMECOLORLABEL.."    /cql wowprogress");
    DEFAULT_CHAT_FRAME:AddMessage(L.ADDONNAMECOLORLABEL.."    /cql raider.io");
    DEFAULT_CHAT_FRAME:AddMessage(L.ADDONNAMECOLORLABEL.."    /cql warcraftlogs");
    DEFAULT_CHAT_FRAME:AddMessage(L.ADDONNAMECOLORLABEL.." You can also generate character links by right clicking on a name in chat, your friends list, or in the Premade Groups lists");
end
frame:SetScript("OnEvent", function(self, event, ...)
 events[event](self, ...); -- call one of the functions above
end);
for k, v in pairs(events) do
 frame:RegisterEvent(k); -- Register all events for which handlers have been defined
end


